﻿using JetBrains.Annotations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using System;
using System.Collections.Generic;
using System.Text;

namespace Common.IdentityServerRepository.MySQL.Converters
{
    public class BoolToShortConverter : ValueConverter<bool, short>
    {
        public BoolToShortConverter([CanBeNull] ConverterMappingHints mappingHints = null)
            : base(
                  v => Convert.ToInt16(v),
                  v => Convert.ToBoolean(v),
                  mappingHints)
        {            
        }

        public static ValueConverterInfo DefaultInfo { get; }
            = new ValueConverterInfo(typeof(bool), typeof(short), i => new BoolToShortConverter(i.MappingHints));
    }
}
