﻿

namespace Common.IdentityServerRepository.MySQL
{
    using Microsoft.Extensions.DependencyInjection;
    using Microsoft.EntityFrameworkCore;
    using System;
    using System.Reflection;
    using Entities;    

    public class RepositoryConfig
    {
        public static void AddIdentityServer(IServiceCollection services, string conString, string migrationsAssembly)
        {
            if (string.IsNullOrEmpty(conString))
                throw new ArgumentException("conString");

            if(string.IsNullOrEmpty(migrationsAssembly))
                migrationsAssembly = Assembly.GetExecutingAssembly().GetName().Name;

            services.AddDbContext<IdentityServerDbContext>(
            options => options.UseMySQL(
                conString,
                builder => builder.MigrationsAssembly(migrationsAssembly)
                )
            );
            services.AddScoped<DbContext, IdentityServerDbContext>();
            services.AddIdentity<MyUser, MyRole>(options => { })
               .AddEntityFrameworkStores<IdentityServerDbContext>()
               .AddUserManager<MyUserManager>()
               .AddManager<MyClientManager>(MyClientManager.Create);               
        }
    }
}
