﻿
namespace Common.IdentityServerRepository.Infrastructure
{    
    using Interfaces;    
    using System;    

    public class IdentityClient<TKey> : IClient<TKey>
        where TKey : IEquatable<TKey>
    {        
        public virtual TKey Id { get; set; }        
        public virtual string ClientName { get; set; }        
        public virtual string Description { get; set; }
        public virtual bool LockoutEnabled { get; set; }        
        public virtual DateTime Created { get; set; } = DateTime.UtcNow;
        public virtual DateTime? Updated { get; set; }
        public virtual DateTime? LastAccessed { get; set; }        
        public virtual TKey UserId { get; set; }        
    }

    public class IdentityClient : IdentityClient<string> {
        
    }
}
