﻿
namespace Common.IdentityServerRepository.Infrastructure
{
    using System;
    using System.ComponentModel.DataAnnotations;
    using Interfaces;
    public class IdentitySecret<TKey> : ISecret<TKey>
        where TKey: IEquatable<TKey>
    {        
        public virtual TKey Id { get; set; }        
        public virtual string Description { get; set; }        
        public virtual string Value { get; set; }
        public virtual DateTime? Expiration { get; set; }        
        public virtual string Type { get; set; } = "SharedSecret";
        public virtual DateTime Created { get; set; } = DateTime.UtcNow;
    }

    public class IdentitySecret : IdentitySecret<string> {

    }
}
