﻿
namespace Common.IdentityServerRepository.Interfaces
{
    using System;
    using System.Collections.Generic;
    using System.Threading.Tasks;

    public interface IClientSecretStore<TClientSecret, TKey> : IStore, IDisposable
        where TClientSecret : IClientSecret<TKey>
        where TKey : IEquatable<TKey>
    {
        void Add(TClientSecret clientSecret);
        void Remove(TClientSecret cleintSecret);        
        Task<List<TClientSecret>> FindByClientAsync(TKey clientId);
        Task<List<TClientSecret>> FindBySecretAsync(TKey secretId);
    }
}
