﻿
namespace Common.IdentityServerRepository.Interfaces
{   
    using System;
    using System.Collections.Generic;
    using System.Threading.Tasks;

    public interface IClientStore<TClient, in TKey>: IStore, IDisposable 
        where TClient : IClient<TKey>
    {
        void Add(TClient client);
        void Remove(TClient client);
        void Modify(TClient client);
        Task<TClient> FindByIdAsync(TKey id);
        Task<List<TClient>> FindByUserAsync(TKey userId);        
    }
}
