﻿
namespace Common.IdentityServerRepository.Interfaces
{
    using System;
    using System.Threading.Tasks;

    public interface ISecretStore<TSecret, in TKey>: IStore, IDisposable
        where TSecret : ISecret<TKey>
    {
        void Add(TSecret secret);
        void Remove(TSecret secret);
        void Modify(TSecret secret);
        Task<TSecret> FindByIdAsync(TKey id);
    }
}
