﻿
namespace Common.IdentityServerRepository.Interfaces
{
    using Infrastructure;
    using Microsoft.EntityFrameworkCore;
    using System;

    public interface IIdentityServerDbContext<TClient, TSecret, TClientSecret, TKey> :
        IClientDbContext<TClient, TKey>,
        ISecretDbContext<TSecret, TKey>,
        IClientSecretDbContext<TClientSecret, TKey>
        where TClient : IdentityClient<TKey>
        where TSecret : IdentitySecret<TKey>
        where TClientSecret : IdentityClientSecret<TKey>
        where TKey : IEquatable<TKey>
    {       
                     
    }
}
